<?php

/************************************/
/*Copyright 2004 by Christian Rutsch*/
/*Contact: christian.rutsch@gmx.de  */
/*Developed und the CCL             */
/************************************/


require_once("lib/villagenav.php");
require_once("lib/quests.php");

function quest_littlegirl_getmoduleinfo(){
	$info = array(
		"name"=>"Quest - Little Girl",
		"version"=>"1.0",
		"author"=>"XChrisX",
		"category"=>"Quest",
		"download"=>"http://beta.lotgd.de/downloads/questpack.zip",
		"requires"=>array(
			"questbasics" => "1.0|XChrisX, http://beta.lotgd.de/downloads/questpack.zip",
			"cities" => "1.0|Eric Stevens, core_module",
			"petra" => "1.0|Shannon Brown, core_module",
			),
		"settings"=>array(
			"req_min_hw" => "Required Hero Points to receive the quest, int|5",
			"req_max_hw" => "Maximum Hero Points to receive the quest, int|10",
			"req_min_dk" => "Required Dragon Kills to receive the quest, int|0",
			"req_max_dk" => "Maximum Dragon Kills to receive the quest, int|0",
			"req_min_lev" => "Minimum level to receive the quest, int|1",
			"req_max_lev" => "Maximum level to receive the quest, int|2",
			"req_quest" => "Is another quest required before starting this quest?, string|",
			"req_superuser" => "Can the quest be done by superusers at any time?, bool|true",
			"reward_exp" => "Reward (Experience), int|1000",
			"reward_explevel" => "Additional experience points per level, int|50",
			"reward_gems" => "Reward (Gems), int|3",
			"reward_gold" => "Reward (Gold), int|1000",
			"reward_goldlevel" => "Additional gold per level, int|75",
			"reward_quest" => "Number of quest points the player receives?, int|50",
		),
		"prefs" => array(
			"queststarted" => "Has the player accepted the quest?, bool|false",
			"queststation" => "What point in the quest is the player at?, int|0",
		),
	);
	return $info;
}

function quest_littlegirl_chance($where){
	global $session;
	$queststation = get_module_pref("queststation", "quest_littlegirl");
	if (requirements_met("quest_littlegirl") || get_module_pref("queststarted", "quest_littlegirl")) {
		if ($where == "village") {
			if (($queststation == 0 || $queststation == 4) && $session[user][location] == get_module_setting("villagename", "racehuman")) {
				$encounter = 50;
			}
		} else if ($where == "forest" && $queststation == 2) {
			$encounter = 100;
		} else {
			$encounter = 0;
		}
		return $encounter;
	} else {
		return 0;
	}
}

function quest_littlegirl_install() {

	$station = array(
		"-2" => "`\$The hero has failed in the attempt to return the toy to the little girl`0",
		"-1" => "`@The hero made the little elven girl happy by bringing her toy back to her.`0",
		"0" => "`6 - The elvish girl and her lost toy - `0",
		"1" => "`6The hero met a crying elven child in Romar who misses her toy.`0",
		"2" => "`6In Glorfindal the hero found that Petra of Petra\'s Tattoo Salon may have found just such a toy, but she sent you out to find a few magic blooms.`0",
		"3" => "`6In a moon-lit clearing the hero found a few blooms of the shadow rose which you must now return to Petra.`0",
		"4" => "`6After the hero delivered the flowers to Petra, Petra has given the toy to the hero.`0",
	);
	$questfilename = "quest_littlegirl";
	db_query("DELETE FROM quests WHERE questname = '".$questfilename."'");
	foreach($station as $outputstation => $entry) {
		$sql = "INSERT INTO quests (questname, queststation, questdescription) VALUES ('".$questfilename."', '".$outputstation."', '".$entry."')";
		db_query($sql);
	}

	module_addeventhook("village", "require_once(\"modules/quest_littlegirl.php\"); return quest_littlegirl_chance(\"village\");");
	module_addeventhook("forest", "require_once(\"modules/quest_littlegirl.php\"); return quest_littlegirl_chance(\"forest\");");
	module_addhook("footer-runmodule");
	return true;
}

function quest_littlegirl_uninstall(){
	return true;
}

function quest_littlegirl_dohook($hookname,$args) {
	global $session, $SCRIPT_NAME;
	$script = substr($SCRIPT_NAME,0,strpos($SCRIPT_NAME,"."));
	if ($script == "runmodule") $script = httpget('module');
	$queststation = get_module_pref("queststation", "quest_littlegirl");
	if ($hookname == "footer-runmodule" && $queststation == 1 && $script == "petra") {
		addnav("-","");
		addnav("Ask Petra about the missing toy", "runmodule.php?module=quest_littlegirl&step=petra1");
	} else if ($hookname == "footer-runmodule" && $queststation == 3 && $script == "petra") {
		addnav("-","");
		addnav("Give the flowers to Petra", "runmodule.php?module=quest_littlegirl&step=petra2");
	}
	return $args;
}

function quest_littlegirl_runevent($type) {
	global $session;

	$queststation = get_module_pref("queststation", "quest_littlegirl");
	$questinprogress = get_module_pref("questinprogress", "questbasics");

	if ($type == "village" && $queststation == 0 && $questinprogress < 1) {
		output("`7A small, crying elven child runs into you in the village, almost knocking you over.`n`n");
		output("\"`&What is wrong?`7\", you ask the little girl.`n`n");
		output("With tears in her eyes she explains that she has only recently arrived in Romar with her parents, and is very unhappy.`n`n");
		output("You start to tell the girl that Romar is one of the most beautiful cities far and wide, but you barely say a word before she begins to cry again.`n`n");
		output("\"`%Yes... It *sniff* isn't so bad... but I lost my favorite toy while we were loading the wagon...`7\", says the girl with a tear-stifled voice.`n`n");
		output("\"`&Perhaps I could help... `7\", you offer to the girl, who looks up at you with joy beaming in her eyes.`n`n");
		output("\"`%Thank you so very much!  I come here often, so you will be able to return the toy to me!`7\", says the girl and she hops happily back to her parents.");
		start_quest("quest_littlegirl");
	} else if ($type == "forest" && $queststation == 2) {
		output("`7You are walking through the close undergrowth of the woods when you come suddenly on a clearing.  Only the pale light of three moons reveals what is in the clearing.`n`n");
		output("In the midst of a group of mushrooms you recognise it: the `\$Shadow Rose`7, that Petra described.  Three single buds have just started to open and stretch themselves towards the largest of the three moons.`n`n");
		output("Carefully you approach the plant and remove the flowers with your knife.`n`n");
		output("Glad that you finally have the `\$Shadow Rose`7 in hand, you start back into the wood.`n`n");
		output("You should visit Petra immediately - you do not want to make the little girl wait needlessly long.");
		advance_quest("quest_littlegirl");
	} else if ($type == "village" && $queststation == 4) {
		page_header("The little girl");
		output("`7Already from far off you see the little girl happily running towards you to get the small fabric animal that has had such a long journey.");
		output("\"`%Thank you very much! You really are a great hero! Mom, Dad, look!!!`7\", quickly the girl is distracted.`n`n");
		output("From the other side of the market place approach a man and a woman, both wearing a long, light blue garb - obviously two elvish priests.`n`n");
		output("\"`2Thank you.  You have returned our daughter's laughter.  Please, take this as a token of our thanks.`7\", says the woman.`n`n");
		output("You take a small bag from the woman and take a glance at your reward.`n`n");
		end_quest("quest_littlegirl");
		villagenav();
		page_footer();
	}
}

function quest_littlegirl_run(){
	global $session;
	$step = httpget('step');

	if ($step == "petra1") {
		page_header("The search for the lost toy");
		output("`7You talk to Petra, and ask whether she might have seen the toy the little girl in Romar misses.`n`n");
		output("Petra tilts her head to the side and her long hair falls gently over her shoulders as she says: \"`6Perhaps... I have too much to do right now, however.. And I have run out of color...`7\"`n`n");
		output("\"`6I will look for it nonetheless`7\", she says, and leads you into her studio. You are overwhelmed by the number of colors Petra uses for her tattoos. You start to ask why she does not use the other colors, when she turns to you.`n`n");
		output("\"`6I could of course use these colors here, but only the buds of the moonlight-picked `\$Shadow Rose `6have the special, magical, qualities I need for my most powerful designs... Unfortunately, I cannot collect supplies at the moment. And I cannot assign my assistant to. But perhaps you could...`7\"`n`n");
		output("With these words she shows you a nearly illegible page from an ancient book.  You have difficulty recognizing the faded letters and designs but you believe you would recognize the flower if you see it.`n`n");
		output("You groan inwardly, but then say to Petra: \"`&Okay, I will search for a few blooms of the Shadow Rose and bring them to you.`7\".`n`n");
		output("With these words you leave to be about your business.");
		advance_quest("quest_littlegirl");
		villagenav();
		page_footer();
	} else if ($step == "petra2") {
		page_header("The search for the lost toy");
		output("`7Completely out of breath, you run into Petra's and call for her'.`n`n");
		output("A few moments later a door opens in the back of the store and Petra approaches you.`n`n");
		output("\"`6Why are you making such a racket!?`7\", she asks, irritably.  But then her gaze falls on the blooms of the `\$Shadow Rose`7 in your hand.`n`n");
		output("\"`6You have actually found them. I would never have thought it would be possible... But what am I saying... Here, have the toy. Give me the flowers carefully...`7\"`n`n");
		output("You notice a strange glitter in Petra's eyes, but you give it no further thought. Finally you have found the toy for the little girl.`n`n");
		output("You leave to make your way to `&Romar`7 and find the little girl.");
		advance_quest("quest_littlegirl");
		villagenav();
		page_footer();
	}
}

?>