<?php

require_once("lib/villagenav.php");

/*
Version History:

1.0 	Released

1.1 	Changed $session['user']['questpoint'] and $session['user']['questpointspent']
		into userprefs to prevent the database fields from being deleted in the forthcoming
		prereleases.
*/

function questbasics_getmoduleinfo(){
	$info = array(
		"name"=>"Quest Basic Installation",
		"version"=>"1.0",
		"author"=>"XChrisX",
		"category"=>"Quest",
		"download"=>"http://beta.lotgd.de/downloads/questpack.zip",
		"prefs" => array(
			"questinprogress" => "Is the player currently engaged with a quest?, bool|false",
			"questinprogressname" => "If so what is the name of this quest?, viewonly",
			"questscompleted" => "How many quests completed?, int|0",
			"questpoint" => "Amount of questpoints the player has received, int|0",
			"questpointspent" => "Amount of questpoints the player has spent, int|0",
		),
	);
	return $info;
}

function questbasics_install(){
	if (!db_table_exists("quests")) {
		debug("Creating Table: 'quests'");
		$sql = "CREATE TABLE quests (entryid int(11) NOT NULL auto_increment, questname VARCHAR(255) NOT NULL, queststation TINYINT(4) NOT NULL, questdescription VARCHAR(255) NOT NULL, PRIMARY KEY (entryid))";
		db_query($sql);
	}
	if (!db_table_exists("questlog")) {
		debug("Creating Table: 'questlog'");
		$sql = "CREATE TABLE questlog (logid int(11) NOT NULL auto_increment, userid int(11) NOT NULL, queststation TINYINT(4) NOT NULL, questname VARCHAR(255) NOT NULL, reachingdate DATETIME NOT NULL, PRIMARY KEY  (logid))";
		db_query($sql);
	}
	module_addhook("village");
	module_addhook("bioinfo");
	module_addhook("biostat");
	module_addhook("dk-preserve");
	return true;
}

function questbasics_uninstall(){
	if (db_table_exists("quests")) {
		debug("Dropping Table: 'quests'");
		$sql = "DROP TABLE quests";
		db_query($sql);
	}
	if (db_table_exists("questlog")) {
		debug("Dropping Table: 'questlog'");
		$sql = "DROP TABLE questlog";
		db_query($sql);
	}
	return true;
}

function questbasics_dohook($hookname,$args){
	global $session;
	switch ($hookname) {
		case "bioinfo":
			if ((int)get_module_pref("questinprogress", "questbasics", $args['acctid']) > 0) {
				$currentquest = get_module_pref("questinprogressname", "questbasics", $args['acctid']);
				$row = db_fetch_assoc(db_query("SELECT questdescription FROM quests WHERE queststation = 0 AND questname = '".$currentquest."'"));
				output("`n`^%s`^ is currently on a Quest `3%s`^.`n", $args[name], $row[questdescription]);
			}
			break;
		case "village":
        	tlschema($args['schemas']['fightnav']);
			addnav($args["fightnav"]);
    		tlschema();
			addnav("Mysterious Hut", "runmodule.php?module=questbasics");
			break;
		case "biostat":
			output("`^Completed Quests:`@ %s`n", (int)get_module_pref("questscompleted", "questbasics", $args[acctid]));
			break;
	}
	return $args;
}

function questbasics_run(){
	global $session;

	$pointsavailable = get_module_pref("questpoint", "questbasics") - get_module_pref("questpointspent", "questbasics");
	$entry = (get_module_pref("questpoint", "questbasics") > 0);
	if ($pointsavailable < 0) $pointsavailable = 0; // something weird.


	$op = httpget('op');
	if ($op == "") checkday();


	page_header("Mysterious Hut");
	if ($op != "" && $entry)
		addnav("Z?Return to the Hut", "runmodule.php?module=questbasics");
	addnav("Questpoints Description","runmodule.php?module=questbasics&op=points");
	villagenav();

	if ($op == ""){
		output("`b`c`!A Mysterious Hut`0`c`b");
		output("`7In the back of the village, just before the training camp, a strange hut leans against the wall of Warchild's Academy.`n");
		output("As you slowly approach the entrance, a man in a blue cloak steps up to you. You try to look at his face beneath the deep folds of the hood, but you cannot recognize anything in the shadows.`n");
		output("The man in the cloak blocks your path towards the entrance to the hut, and you feel an unknown strength attempting to penetrate your mind.`n`n");

		if ($entry){
			output("\"`6Ah, %s, be welcome to our modest home!`7\", a voice speaks inside your head.", ($session['user']['sex']?"valiant lady":"courageous sir"));
			output("\"`6You have already received `^%s`6 Questpoints from which `^%s`6 Points are available.\"`7 he says to you and motions for you to enter the hut.`n`n", $session['user']['questpoint'], $pointsavailable);
			output("You enter the hut and are very surprised by the sight which greets you.");
			output("While the hut looks dilapidated on the outside, true luxury appears to rule inside which emperors and kings could not match.`n`n");
			output("\"`6We prefer that people not see us as much. Therefore we hide the treasures, which we find on our adventures, from the eyes of the simple populace.`7\"");
			output("You are still overwhelmed by the almost limitless wealth which threatens to rush in from all sides as the voice announces itself inside your mind again.`n`n");
			output("\"`6Here you will find reward for your past adventures...`7\"");
			output("With these words the man in the blue cloak turns away and leaves you in the middle of the room.`n`n");
			addnav("Use Points");
			modulehook("questhut");
		} else {
			output("After a moment that feels like eternity, you find yourself back in the village.");
			output("You have the feeling you were not welcome.");
		}
	} else if ($op=="points") {
		output("`b`3Points:`b`n`n");
		output("`7For each completed quest you receive a number of `&Questpoints`7 in return.`n");
		output("\"`&What good are these points,`7\" you ask?`n");
		output("The points can be exchanged for special things that are not available to every player.");
		output("In the mysterious hut near the training camp you can exchange these points.");
		output("From time to time more things will become available for you to buy.`n`n");
		output("Unlike `&Donation points`7, there is no way to receive these points except through play.`n`n");
		output("`b`3Currently, you can purchase:`0`b`n");
		$args = modulehook("questhutpointsdesc", array("format"=>"`#&#149;`7 %s`n", "count"=>0));
		if ($args['count'] == 0) {
			output("`#&#149; `7Nothing -- please ask the admin to add things to buy.`n", true);
		}
	}

	page_footer();
}
?>