<?php

/************************************/
/*Copyright 2004 by Christian Rutsch*/
/*Contact: christian.rutsch@gmx.de  */
/*Developed und the CCL             */
/************************************/


require_once("lib/villagenav.php");
require_once("lib/quests.php");

function quest_littlegirl_getmoduleinfo(){
	$info = array(
		"name"=>"Quest - Little Girl",
		"version"=>"1.0",
		"author"=>"XChrisX",
		"category"=>"Quest",
		"download"=>"http://www.lotgd.de/downloads/questpack.zip",
		"requires"=>array(
			"questbasics" => "1.0|XChrisX, http://www.lotgd.de/downloads/questpack.zip",
			"cities" => "1.0|Eric Stevens, core_module",
			"petra" => "1.0|Shannon Brown, core_module",
			),
		"settings"=>array(
			"req_min_hw" => "Bentigte Heldenwege zum Freischalten der Missionen, int|5",
			"req_max_hw" => "Maximale Heldenwege zum Freischalten der Missionen, int|10",
			"req_min_dk" => "Bentigte Drachenkills zum Freischalten der Missionen, int|0",
			"req_max_dk" => "Maximale Drachenkills zum Freischalten der Missionen, int|0",
			"req_min_lev" => "Bentigtes Level zum Freischalten der Missionen, int|1",
			"req_max_lev" => "Maximale Level zum Freischalten der Missionen, int|2",
			"req_quest" => "Wird ein anderer Quest bentigt zum Start dieses Quests?, string|",
			"req_superuser" => "Kann der Quest von Superusern jederzeit ausgefhrt werden?, bool|true",
			"reward_exp" => "Belohnung (Erfahrung), int|1000",
			"reward_explevel" => "zustzliche Erfahrungspunkte pro Level, int|50",
			"reward_gems" => "Belohnung (Edelsteine), int|3",
			"reward_gold" => "Belohnung (Goldstcke), int|1000",
			"reward_goldlevel" => "zustzliche Goldstcke pro Level, int|75",
			"reward_quest" => "Wie viele Quest-Punkte erhlt der Spieler?, int|50",
		),
		"prefs" => array(
			"queststarted" => "Hat der Spieler den Auftrag angenommen?, bool|false",
			"queststation" => "An welcher Stelle befindet sich der Spieler zur Zeit?, int|0",
		),
	);
	return $info;
}

function quest_littlegirl_chance($where){
	global $session;
	$queststation = get_module_pref("queststation", "quest_littlegirl");
	if (requirements_met("quest_littlegirl") || get_module_pref("queststarted", "quest_littlegirl")) {
		if ($where == "village") {
			if (($queststation == 0 || $queststation == 4) && $session[user][location] == get_module_setting("villagename", "racehuman")) {
				$encounter = 50;
				if ($queststation == 4) $encounter = 100;
			}
		} else if ($where == "forest" && $queststation == 2) {
			$encounter = 100;
		} else {
			$encounter = 0;
		}
		return $encounter;
	} else {
		return 0;
	}
	return 0;
}


function quest_littlegirl_install() {

	$station = array(
		"-2" => "`\$Der Held hat es nicht geschafft, dem kleinen Mdchen ihr Spielzeug wiederzubringen.`0",
		"-1" => "`@Der Held hat es geschafft, das kleine Elfenmdchen glcklich zu machen, in dem er ihr das Spielzeug zurckgebracht hat.`0",
		"0" => "`6 - Das Elfenmdchen und das verlorene Spielzeug - `0",
		"1" => "`6Der Held hat in Romar ein kleines, weinendes Elfenmdchen getroffen, dass sein Spielzeug vermisst.`0",
		"2" => "`6In Glorfindal hat der Held bei Petras Tattoo-Salon erfahren, dass Petra so ein Spielzeug gefunden haben knnte, aber ihr grade ein paar magische Blten ausgegangen sind.`0",
		"3" => "`6Auf einer mondbeschienenen Lichtung hat der Held ein paar Blten der Schattenrose gefunden, die er nun zu Petra bringen muss.`0",
		"4" => "`6Nachdem der Held bei Petra die Blten der Schattenrose abgegeben hat, hat Petra dem Helden das Spielzeug gegeben.`0",
	);
	$questfilename = "quest_littlegirl";
	db_query("DELETE FROM quests WHERE questname = '".$questfilename."'");
	foreach($station as $outputstation => $entry) {
		$sql = "INSERT INTO quests (questname, queststation, questdescription) VALUES ('".$questfilename."', '".$outputstation."', '".$entry."')";
		db_query($sql);
	}

	module_addeventhook("village", "require_once(\"modules/quest_littlegirl.php\"); return quest_littlegirl_chance(\"village\");");
	module_addeventhook("forest", "require_once(\"modules/quest_littlegirl.php\"); return quest_littlegirl_chance(\"forest\");");
	module_addhook("footer-runmodule");
	module_addhook("newday");
	return true;
}

function quest_littlegirl_uninstall(){
	return true;
}

function quest_littlegirl_dohook($hookname,$args) {
	global $session, $SCRIPT_NAME;
	$script = substr($SCRIPT_NAME,0,strpos($SCRIPT_NAME,"."));
	if ($script == "runmodule") $script = httpget('module');
	$queststation = get_module_pref("queststation", "quest_littlegirl");
	if ($hookname == "footer-runmodule" && $queststation == 1 && $script == "petra") {
		addnav("-","");
		addnav("Petra nach dem verschwundenen Spielzeug fragen", "runmodule.php?module=quest_littlegirl&step=petra1");
	} else if ($hookname == "footer-runmodule" && $queststation == 3 && $script == "petra") {
		addnav("-","");
		addnav("Petra die Blumenblten geben", "runmodule.php?module=quest_littlegirl&step=petra2");
	}
	return $args;
}

function quest_littlegirl_runevent($type) {
	global $session;

	$queststation = get_module_pref("queststation", "quest_littlegirl");
	$questinprogress = get_module_pref("questinprogress", "questbasics");

	if ($type == "village" && $queststation == 0 && $questinprogress < 1) {
		output("`7Ein kleines, weinendes Elfenmdchen kommt dir auf dem Dorfplatz entgegen und rennt dich beinahe um.`n`n");
		output("\"`&Was hast du denn?`7\", fragst du das kleine Mdchen.`n`n");
		output("Mit Trnen in den Augen erklrt dir das kleine Mdchen, dass es grade erst mit seinen Eltern hier nach Romar gezogen ist und sehr unglcklich ist.`n`n");
		output("Du versuchst dem Mdchen klar zu machen, dass Romar doch eine der schnsten Stdte weit und breit sei, kommst aber kaum zu Wort, weil das Mdchen wieder anfngt zu weinen.`n`n");
		output("\"`%Ja... so schlimm *schnff* ist es auch nicht... Ich habe nur mein Lieblingsspielzeug verloren, als wir unsere Sachen auf den Wagen geladen haben...`7\", sagt das Mdchen mit trnenerstickter Stimme.`n`n");
		output("\"`&Vielleicht knnte ich ja helfen... `7\", bietest du dem Mdchen an, dass dich daraufhin mit freudestrahlenden Augen anguckt.`n`n");
		output("\"`%Vielen, vielen Dank! Ich werde mich hier regelmig umgucken, damit du mir mein Spielzeug wiedergeben kannst!`7\", sagt das Mdchen und hpft freudig zurck zu seinen Eltern.");
		start_quest("quest_littlegirl");
		villagenav();
		page_footer();
	} else if ($type == "forest" && $queststation == 2) {
		output("`7Du trittst durch das dicht Unterholz des Waldes, als du pltzlich auf eine Lichtung kommst. Nur das fahle Licht der drei Monde lsst dich erkennen, was sich auf der Lichtung befindet.`n`n");
		output("Inmitten einer Gruppe von Pilzen erkennst du sie: Die `\$Schattenrose`7, die Petra dir beschrieben hat. Drei einzelne Knospen beginnen grade sich zu ffnen und recken sich dem grten der drei Monde zu.`n`n");
		output("Vorsichtig nherst Du dich der Pflanze um eine der Knospen mit einem Messer vosichtig von der Pflanze abzutrennen.`n`n");
		output("Froh darber, dass du die `\$Schattenrose`7 endlich gefunden hast, machst du dich auf, zurck in den Wald.`n`n");
		output("Du solltest Petra schleunigst einen Besuch abstatten - schlielich willst Du das kleine Mdchen ja nicht unntig lange warten lassen.");
		advance_quest("quest_littlegirl");
	} else if ($type == "village" && $queststation == 4) {
		page_header("Das kleine Mdchen");
		output("`7Schon von weitem siehst du das kleine Mdchen freudig auf dich zu laufen und holst das kleine Stofftier aus deinem Rucksack, dass jetzt schon eine so weite Reise hinter sich gebracht hat.");
		output("\"`%Vielen Dank! Du bist wirklich ein groooooer Held! Mami, Papi, schaut mal!!!`7\", quickt das Mdchen vergngt.`n`n");
		output("Von der anderen Seite des Marktplatzes nhern sich ein Mann und eine Frau, die beide ein langes, hellblaues Gewand tragen - offensichtlich zwei elfische Priester.`n`n");
		output("\"`2Vielen Dank. Ihr habt unserer Tochter das Lachen wiedergegeben. Bitte, nehmt dieses als Zeichen unseres Dankes.`7\", sagt die Frau.`n`n");
		output("Du nimmst der Frau den kleinen Beutel ab und wirfst einen Blick auf deine Belohnung.`n`n");
		end_quest("quest_littlegirl");
		villagenav();
		page_footer();
	}
}


function quest_littlegirl_run(){
	global $session;
	$step = httpget('step');

	if ($step == "petra1") {
		page_header("Die Suche nach dem verlorenen Spielzeug");
		output("`7Du sprichst Petra an, und fragst sie, ob sie vielleicht das Spielzeug gesehen hat, dass das kleine Mdchen aus Romar vermisst.`n`n");
		output("Petra legt ihren Kopf ein wenig zur Seite und ihr langes Haar fllt sanft ber ihre Schultern als sie sagt: \"`6Vielleicht... Ich hab aber im Moment viel zu viel zu tun.. Und dann ist mir auch noch die Farbe ausgegangen...`7\"`n`n");
		output("\"`6Schau es dir doch selber an`7\", sagt sie zu dir und fhrt dich in ihr Atelier. Du bist berwltigt von der Auswahl an Farben, die Petra fr ihre Tattoos zu verwenden scheint. Grade willst du Sie fragen, warum sie denn nicht die anderen Farben vewendet, als sie sich dir zuwendet.`n`n");
		output("\"`6Ich knnte natrlich auch diese Farben hier verwenden, aber nur die Knospen der bei Mondschein gepflckten `\$Schattenrose `6haben die besonderen, magischen Eigenschaften, die ich fr meine mchtigsten Zeichnungen bentige... Leider komme ich zur Zeit berhaupt nicht dazu, mir Nachschub zu sammeln. Und meinen Assistenten kann ich damit nicht beauftragen. Aber vielleicht knntest du ja...`7\"`n`n");
		output("Mit diesen Worten zeigt sie dir eine fast vergilbte Seite aus einem uralten Buch. Du hast Mhe, die verblichenen Buchstaben und Zeichnungen zu erkennen, glaubst aber, dass du die Blume erkennen wrdest, wenn du sie siehst.`n`n");
		output("Du sthnst leise auf, sagst dann aber zu Petra: \"`&Okay, ich werde fr Euch ein paar Bltenbltter der Schattenrose suchen und sie euch bringen.`7\".`n`n");
		output("Mit diesen Worten verlsst du Ihr Geschft.");
		advance_quest("quest_littlegirl");
		villagenav();
		page_footer();
	} else if ($step == "petra2") {
		page_header("Die Suche nach dem verlorenen Spielzeug");
		output("`7Vollkommen auer Atem strzt in Petras Atelier und rufst nach ihr.`n`n");
		output("Wenige Momente spter ffnet sich eine Tr im hinteren Bereich des Geschfts und Petra kommt auf dich `zu.`n`n");
		output("\"`6Was machst du denn hier fr einen Aufstand!?`7\", fragt sie ein wenig rgerlich. Aber dann fllt ihr Blick auf die Blte der `\$Schattenrose`7 in deiner Hand.`n`n");
		output("\"`6Du hast sie tatschlich gefunden. Ich htte niemals gedacht, dass das mglich sein knnte... Aber was red ich da... Hier, da hast du dein Spielzeug. Gib mir ruhig die Blte...`7\"`n`n");
		output("Du bemerkst ein eigenartiges Glitzern in Petras Augen, machst dir aber darber keine weiteren Gedanken. Schlielich hast du jetzt ja das Spielzeug fr das kleine Mdchen gefunden.`n`n");
		output("Du sollstest dich auf den Weg nach `&Romar`7 machen und nach dem Mdchen Ausschau halten.");
		advance_quest("quest_littlegirl");
		villagenav();
		page_footer();
	}
}

?>