<?php

require_once("lib/villagenav.php");

/*
Version History:

1.0 	Released

1.1 	Changed $session['user']['questpoint'] and $session['user']['questpointspent']
		into userprefs to prevent the database fields from being deleted in the forthcoming
		prereleases.
*/

function questbasics_getmoduleinfo(){
	$info = array(
		"name"=>"Quest Basic Installation",
		"version"=>"1.1",
		"author"=>"XChrisX",
		"category"=>"Quest",
		"download"=>"http://beta.lotgd.de/downloads/questpack.zip",
		"prefs" => array(
			"questinprogress" => "Is the player currently engaged with a quest?, bool|false",
			"questinprogressname" => "If so what is the name of this quest?, viewonly",
			"questscompleted" => "How many quests completed?, int|0",
			"questpoint" => "Amount of questpoints the player has received, int|0",
			"questpointspent" => "Amount of questpoints the player has spent, int|0",
		),
	);
	return $info;
}

function questbasics_install(){
	if (!db_table_exists("quests")) {
		debug("Creating Table: 'quests'");
		$sql = "CREATE TABLE quests (entryid int(11) NOT NULL auto_increment, questname VARCHAR(255) NOT NULL, queststation TINYINT(4) NOT NULL, questdescription VARCHAR(255) NOT NULL, PRIMARY KEY (entryid))";
		db_query($sql);
	}
	if (!db_table_exists("questlog")) {
		debug("Creating Table: 'questlog'");
		$sql = "CREATE TABLE questlog (logid int(11) NOT NULL auto_increment, userid int(11) NOT NULL, queststation TINYINT(4) NOT NULL, questname VARCHAR(255) NOT NULL, reachingdate DATETIME NOT NULL, PRIMARY KEY  (logid))";
		db_query($sql);
	}
	module_addhook("village");
	module_addhook("bioinfo");
	module_addhook("biostat");
	return true;
}

function questbasics_uninstall(){
	if (db_table_exists("quests")) {
		debug("Dropping Table: 'quests'");
		$sql = "DROP TABLE quests";
		db_query($sql);
	}
	if (db_table_exists("questlog")) {
		debug("Dropping Table: 'questlog'");
		$sql = "DROP TABLE questlog";
		db_query($sql);
	}
	return true;
}

function questbasics_dohook($hookname,$args){
	global $session;
	switch ($hookname) {
		case "bioinfo":
			if ((int)get_module_pref("questinprogress", "questbasics", $args['acctid']) > 0) {
				$currentquest = get_module_pref("questinprogressname", "questbasics", $args['acctid']);
				$row = db_fetch_assoc(db_query("SELECT questdescription FROM quests WHERE queststation = 0 AND questname = '".$currentquest."'"));
				output("`n`^%s`^ befindet sich grade auf dem Quest `3%s`^.`n", $args[name], $row[questdescription]);
			}
			break;
		case "village":
        	tlschema($args['schemas']['fightnav']);
			addnav($args["fightnav"]);
    		tlschema();
			addnav("Mysterise Htte", "runmodule.php?module=questbasics");
			break;
		case "biostat":
			output("`^Abgeschlossene Quests:`@ %s`n", (int)get_module_pref("questscompleted", "questbasics", $args[acctid]));
			break;
	}
	return $args;
}

function questbasics_run(){
	global $session;

	$pointsavailable = get_module_pref("questpoint", "questbasics") - get_module_pref("questpointspent", "questbasics");
	$entry = (get_module_pref("questpoint", "questbasics") > 0);
	if ($pointsavailable < 0) $pointsavailable = 0; // something weird.


	$op = httpget('op');
	if ($op == "") checkday();


	page_header("Mysterise Htte");
	if ($op != "" && $entry)
		addnav("Z?Zurck in die Htte", "runmodule.php?module=questbasics");
	addnav("Questpunkte beschreiben","runmodule.php?module=questbasics&op=points");
	villagenav();

	if ($op == ""){
		output("`b`c`!Eine Mysterise Htte`0`c`b");
		output("`7Im hinteren Bereich des Dorfes, kurz vor dem Trainingslager lehnt diese seltsame Htte an der Mauer zu Warchilds Akademie.`n");
		output("Vorsichtig nherst du dich dem Eingang, als ein Mann in einer tiefblauen Kutte auf dich zu tritt. Du versuchst ein Gesicht hinter den tiefen Falten der Kutte zu erkennen, aber du kannst nichts als Schatten erkennen.`n");
		output("Der Mann in der Kutte stellt sich dir in den Weg, als du auf den Eingang der Htte zusteuerst und du sprst, wie eine unbekannte Kraft versucht in deinen Geist einzudringen.`n`n");

		if ($entry){
			output("\"`6Ah, %s, seid willkommen in unserem bescheidenem Heim!`7\", sagt eine Stimme in deinem Kopf.", ($session['user']['sex']?"heldenhafte Jungfer":"tapferer Recke"));
			output("\"`6Du hast bereits `^%s`6 Questpunkte erhalten, von denen dir noch `^%s`6 Punkte zur Verfgung stehen.\"`7 sagt er dir und bittet dich in die Htte.`n`n", $session['user']['questpoint'], $pointsavailable);
			output("Du betrittst die Htte und bist doch sehr berrascht ber den Anblick, der sich dir bietet.");
			output("Whrend die Htte von auen relativ heruntergekommen wirkt, erscheint im Inneren der wahre Luxus zu herrschen, wie ihn sich nicht einmal Kaiser und Knige leisten knnten.`n`n");
			output("\"`6Wir ziehen es vor, wenn man uns von uns nicht so viel erfhrt. Deswegen verstecken wir die Schtze, die wir auf unseren Abenteuern finden, lieber vor den Augen der einfachen Bevlkerung.`7\"");
			output("Du bist immernoch von dem schier grenzenloses Reichtum berwltigt, der von allen Seiten auf dihc hereinzustrzen droht, als sich die Stimme in deinem Kopf wieder meldet.`n`n");
			output("\"`6Hier sollst du Belohnung fr deine bestandenen Abenteuer finden...`7\"");
			output("Mit diesen Worten wendet sich der Mann in der blauen Kutte ab und lsst dich in der Mitte des Raumes stehen.`n`n");
			addnav("Punkte benutzen");
			modulehook("questhut");
		} else {
			output("Nach einem Moment, der dir wie die Ewigkeit vorkommt, findest du dich auf dem Dorfplatz wieder.");
			output("Irgendwie hast du das Gefhl, hier nicht willkommen zu sein.");
		}
	} else if ($op=="points") {
		output("`b`3Punkte:`b`n`n");
		output("`7Fr jeden bestandenen Quest wirst du mit einer bestimmten Anzahl von `&Questpunkten`7 belohnt.`n");
		output("\"`&Wofr sind diese Punkte gut,`7\" fragst du dich sicherlich?`n");
		output("Die Punkte knnen gegen ganz besondere Sachen eingetauscht werden, die nicht jedem Spieler zur Verfgung stehen.");
		output("ber die mysterise Htte neben dem Trainingslager kannst du diese Punkte umtauschen.");
		output("Von Zeit zu Zeit werden weitere Sachen verfgbar werden, die Du kaufen kannst.`n`n");
		output("Anders als bei den `&Donationpoints`7 gibt es keine Mglichkeit auer durch das Spiel selbst, an diese Punkte zu kommen.`n`n");
		output("`b`3Sachen, die du im Moment kaufen kannst:`0`b`n");
		$args = modulehook("questhutpointsdesc", array("format"=>"`#&#149;`7 %s`n", "count"=>0));
		if ($args['count'] == 0) {
			output("`#&#149; `7Keine -- Bitte rede mit den Admins, dass die welche einbauen.`n", true);
		}
	}

	page_footer();
}
?>